/***************************************************************************
                          DangerBar.cpp  -  description
                             -------------------
    begin                : Tue Dec 18 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "DangerBar.h"
#include <qpainter.h>

DangerBar::DangerBar(QWidget *parent, const char *name )
	: QWidget(parent,name)
{
	m_barSteps = 5;
	m_fill = 0;
	setBackgroundColor(QColor(255,0,0));
}

DangerBar::~DangerBar()
{
}

void DangerBar::setBarSteps(int steps)
{
	m_barSteps = steps;
}

void DangerBar::step()
{
	increase(1);
}

void DangerBar::setPos(int pos)
{
	m_fill = pos;
	if(m_fill < 0)
		m_fill = 0;
	else if(m_fill > m_barSteps)
	{
		m_fill = 0;
		emit overFlow();
	}
	update();
}

void DangerBar::increase(int n)
{
	setPos(m_fill+n);
}

void DangerBar::decrease(int n)
{
	setPos(m_fill-n);
}

void DangerBar::reset()
{
	setPos(0);
}
	
void DangerBar::paintEvent(QPaintEvent *pe)
{
	QPainter p(this);
	
	p.setPen(yellow);
	p.setBrush(yellow);
	p.drawRect(0, height()-m_fill*height()/m_barSteps, width(), height());
}
