/***************************************************************************
                          DangerBar.h  -  description
                             -------------------
    begin                : Tue Dec 18 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DANGERBAR_H
#define DANGERBAR_H

#include <qwidget.h>

/**
  *@author Thorsten Scheuermann
  */

class DangerBar : public QWidget
{
   Q_OBJECT

public:
	DangerBar(QWidget *parent=0, const char *name=0);
	~DangerBar();

signals:
	void overFlow();
	
public slots:
	void setBarSteps(int steps);
	void step();
	void increase(int n);
	void decrease(int n);
	void setPos(int pos);
	void reset();
	
protected:
	virtual void paintEvent(QPaintEvent *pe);
	
	int m_barSteps;
	int m_fill;
};

#endif
