/***************************************************************************
                          FrootApp.h  -  description
                             -------------------
    begin                : Wed Dec 5 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FROOTAPP_H
#define FROOTAPP_H

#include <qwidget.h>

/**
  *@author Thorsten Scheuermann
  */

class MenuWidget;
class GameWidget;
class AboutWidget;
class GameSettings;
class HighscoreTable;
class SoundPlayer;

class FrootApp : public QWidget
{
   Q_OBJECT

public:
	FrootApp(QWidget *parent=0, const char *name=0);
	~FrootApp();

public slots:
	void startGame();
	void showMenu();
	void setDifficulty(int level);
	void addHighscore(int score);
	void showOptionsDialog();
	void resetHighscores();

protected:
	void loadSettings();
	void saveSettings();

	MenuWidget *m_menuWidget;
	GameWidget *m_gameWidget;
	AboutWidget *m_aboutWidget;
	SoundPlayer *m_soundPlayer;

	int m_currentSettings;
	GameSettings *m_settings[4];
	HighscoreTable *m_highscore[4];
	QString m_name;			// the last name entered for a highscore
};

#endif
