/***************************************************************************
                          GameOverState.h  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEOVERSTATE_H
#define GAMEOVERSTATE_H

#include "GameState.h"
#include <qfont.h>
#include <qfontmetrics.h>

/**
  *@author Thorsten Scheuermann
  */

class QCanvasText;
class QTimer;

class GameOverState : public GameState
{
	Q_OBJECT

public:
	GameOverState(GameWidget *gl);
	virtual ~GameOverState();

	virtual enum State type();
	virtual void initialize();
	virtual void keyPressEvent(QKeyEvent *e);

protected slots:
	void stopGame();

protected:
	virtual void mousePressEvent(QMouseEvent *e);

	QFont m_bigFont;
	QFont m_smallFont;
	QFontMetrics m_bigMetrics;
	QFontMetrics m_smallMetrics;
	QCanvasText *m_mainText[5];
	QCanvasText *m_bonusText[5];
	QTimer *m_timer;
};

#endif
