/***************************************************************************
                          GameSettings.cpp  -  description
                             -------------------
    begin                : Tue Dec 18 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "GameSettings.h"

GameSettings::GameSettings(int barSteps, int startRows, int numBadPieces,
													 int bonusBaseScore)
{
	m_barSteps = barSteps;
	m_startRows = startRows;
	m_badPieceCount = numBadPieces;
	m_bonusBaseScore = bonusBaseScore;
}

GameSettings::~GameSettings()
{
}

void GameSettings::setBarSteps(int steps)
{
	m_barSteps = steps;
}

void GameSettings::piecesRemoved(int numDirect, int numIndirect)
{
	if(!numIndirect)
		emit increaseBar(1);
	else
		emit decreaseBar(numIndirect);
}

