/***************************************************************************
                          GameState.h  -  description
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMESTATE_H
#define GAMESTATE_H


/**
  *@author Thorsten Scheuermann
  */

#include <qobject.h>

class GameWidget;
class QKeyEvent;
class QMouseEvent;

class GameState : public QObject
{
public:
	GameState(GameWidget *gl);
	virtual ~GameState();

	enum State {Idle, Aiming, Moving, Remove, GameOver};

	virtual enum State type() = 0;
	virtual void initialize();
	virtual void update();
	virtual void reset();
	virtual void keyPressEvent(QKeyEvent *e);
	virtual void keyReleaseEvent(QKeyEvent *e);
	virtual void mousePressEvent(QMouseEvent *e);

protected:
	GameWidget *m_myLogic;
};

#endif
