/***************************************************************************
                          HighscoreWidget.cpp  -  description
                             -------------------
    begin                : Sat Jan 12 2002
    copyright            : (C) 2002 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "HighscoreWidget.h"
#include "HighscoreTable.h"
#include <qpainter.h>

//----------------------------------------------------------------------------------------
HighscoreWidget::HighscoreWidget(QWidget *parent, const char *name)
	: QWidget(parent,name)
{
	m_scoreTable = NULL;
}
//----------------------------------------------------------------------------------------
HighscoreWidget::~HighscoreWidget()
{
}
//----------------------------------------------------------------------------------------
void HighscoreWidget::setScores(HighscoreTable *scoreTable)
{
	m_scoreTable = scoreTable;
	repaint();
}
//----------------------------------------------------------------------------------------
void HighscoreWidget::paintEvent(QPaintEvent *)
{
	QPainter paint(this);
	int i;
	int y;
	int dy = fontMetrics().height();
	int indexWidth = fontMetrics().width("99.");
	int scoreWidth = fontMetrics().width("999999");
	QString tString;
	
	paint.setPen(white);
	for(i=0, y=0; i<10; i++, y+=dy)
	{
		if(i == m_scoreTable->getLatestEntryPos())
			paint.setPen(green);
		else
			paint.setPen(white);

		// print number (right-aligned)
		tString = QString::number(i+1) + '.';
		paint.drawText(0, y, indexWidth, dy, AlignRight|AlignVCenter, tString);
	}

	if(!m_scoreTable)
		return;

	for(i=0, y=0; i<m_scoreTable->numEntries(); i++, y+=dy)
	{
		if(i == m_scoreTable->getLatestEntryPos())
			paint.setPen(green);
		else
			paint.setPen(white);

		// print name (left-aligned)
		paint.drawText(indexWidth+5, y, width()-indexWidth-scoreWidth, dy,
									 AlignLeft|AlignVCenter, m_scoreTable->getName(i));
		// print score (right-aligned)
		tString = QString::number(m_scoreTable->getScore(i));
		paint.drawText(width()-scoreWidth, y, scoreWidth, dy,
									 AlignRight|AlignVCenter, tString);
	}
}
//----------------------------------------------------------------------------------------
