/***************************************************************************
                          Launcher.h  -  description
                             -------------------
    begin                : Wed Dec 5 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LAUNCHER_H
#define LAUNCHER_H

#include <qobject.h>
#include <qcanvas.h>
#include <qpoint.h>

/**
  *@author Thorsten Scheuermann
  */

class GameBoard;
class Piece;

class Launcher : public QObject
{
Q_OBJECT

public: 
	Launcher(GameBoard *gameBoard, const char *name=0);
	~Launcher();

public slots:
	void reset();
	void update();
	void turnLeft(bool on);
	void turnRight(bool on);
	void setPosition(QPoint s);
	void setPiece(Piece *p);
	void launchPiece();
	
protected:
	void updateTurretPos();

	enum TurnDir {Stop, Left, Right};
	enum TurnDir m_turnDir;	

	QCanvasSprite *m_base;
	QCanvasSprite *m_turret[4];
	float m_turretRadius[4];
	float m_angle;
	QPoint m_pos;
	Piece *m_loadedPiece;
	float m_speed;
	static const float ACCEL;
	static const float MAX_SPEED;
};

#endif
