/***************************************************************************
                          LauncherTurnState.cpp  -  description
                             -------------------
    begin                : Fri Jan 11 2002
    copyright            : (C) 2002 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "LauncherTurnState.h"
#include "GameWidget.h"
#include "Launcher.h"
#include <qevent.h>

//----------------------------------------------------------------------------------------
LauncherTurnState::LauncherTurnState(GameWidget *gl)
	: GameState(gl)
{
}
//----------------------------------------------------------------------------------------
LauncherTurnState::~LauncherTurnState()
{
}
//----------------------------------------------------------------------------------------
void LauncherTurnState::keyPressEvent(QKeyEvent *e)
{
	if(e->isAutoRepeat())
		return;
		
	switch(e->key())
	{
	case Qt::Key_Left:
		m_myLogic->m_launcher->turnLeft(true);
		break;

	case Qt::Key_Right:
		m_myLogic->m_launcher->turnRight(true);
		break;
		
	default:
		GameState::keyPressEvent(e);
	}
}
//----------------------------------------------------------------------------------------
void LauncherTurnState::keyReleaseEvent(QKeyEvent *e)
{
	if(e->isAutoRepeat())
		return;
		
	switch(e->key())
	{
	case Qt::Key_Left:
		m_myLogic->m_launcher->turnLeft(false);
		break;
		
	case Qt::Key_Right:
		m_myLogic->m_launcher->turnRight(false);
		break;
		
	default:
		e->ignore();
	}
}
//----------------------------------------------------------------------------------------
