/***************************************************************************
                          PieceCounter.h  -  description
                             -------------------
    begin                : Mon Dec 17 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PIECECOUNTER_H
#define PIECECOUNTER_H


/**
  *@author Thorsten Scheuermann
  */

class Piece;

class PieceCounter
{
public: 
	PieceCounter(int numTypes);
	~PieceCounter();
	
	void reset();
	void addPiece(Piece *p);
	void removePiece(Piece *p);
	inline int totalPiecesLeft() const;
	inline int piecesLeft(int type) const;
	int getRandomRemainingType() const;
	
protected:
	void recalcTypesLeft();
	
	int m_numTypes;					// the number of different piece types there is
	int m_numTypesLeft;			// the number of piece types that are left
	int *m_numPiecesLeft;		// the number of pieces left for each type
	int *m_typesLeft;				// the types of which pieces are left
	int m_totalPiecesLeft;	// the total number of pieces left
};

inline int PieceCounter::totalPiecesLeft() const
{
	return m_totalPiecesLeft;
}

inline int PieceCounter::piecesLeft(int type) const
{
	return m_numPiecesLeft[type];
}

#endif
