/***************************************************************************
                          PieceFactory.cpp  -  description
                             -------------------
    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "PieceFactory.h"
#include "Piece.h"
#include <qcanvas.h>
#include <stdlib.h>
#include <qpe/qpeapplication.h>

PieceFactory::PieceFactory()
{
	m_pmArray = new QCanvasPixmapArray[8];
	m_pmArray[0].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece1%1.png", 2);
	m_pmArray[1].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece2%1.png", 2);
	m_pmArray[2].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece3%1.png", 2);
	m_pmArray[3].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece4%1.png", 2);
	m_pmArray[4].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece5%1.png", 2);
	m_pmArray[5].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece6%1.png", 2);
	m_pmArray[6].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece7%1.png", 2);
	m_pmArray[7].readPixmaps(QPEApplication::qpeDir()+"pics/froot/piece8.png");
	m_numArrays = 7;
}

PieceFactory::~PieceFactory()
{
	delete[] m_pmArray;
}

Piece *PieceFactory::createPiece(int type, GameBoard *theBoard)
{
	return new Piece(type, &m_pmArray[type%m_numArrays], theBoard);
}

Piece *PieceFactory::createBadPiece(GameBoard *theBoard)
{
	return new Piece(7, &m_pmArray[7], theBoard);
}

Piece *PieceFactory::createRandomPiece(GameBoard *theBoard)
{
	int t = rand() % m_numArrays;
	return new Piece(t, &m_pmArray[t], theBoard);
}

int PieceFactory::numTypes() const
{
	return m_numArrays;
}
