/***************************************************************************
                          PieceFactory.h  -  description
                             -------------------
    begin                : Thu Dec 6 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PIECEFACTORY_H
#define PIECEFACTORY_H


/**
  *@author Thorsten Scheuermann
  */

class GameBoard;
class Piece;
class QCanvasPixmapArray;

class PieceFactory
{
public: 
	PieceFactory();
	~PieceFactory();
	
	Piece *createPiece(int type, GameBoard *theBoard);
	Piece *createBadPiece(GameBoard *theBoard);
	Piece *createRandomPiece(GameBoard *theBoard);
	int numTypes() const;
	
protected:
	QCanvasPixmapArray *m_pmArray;
	int m_numArrays;
};

#endif
