/***************************************************************************
                          RemoveState.h  -  description
                             -------------------
    begin                : Mon Dec 24 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef REMOVESTATE_H
#define REMOVESTATE_H

#include "LauncherTurnState.h"
#include <qlist.h>
#include <qpoint.h>

/**
  *@author Thorsten Scheuermann
  */

class Piece;

class RemoveState : public LauncherTurnState
{
public: 
	RemoveState(GameWidget *gl);
	~RemoveState();
	
	virtual enum State type();
	virtual void initialize();
	virtual void update();
	virtual void reset();

protected:
	bool removePieces(QPoint &startingPoint);
	
	QList<Piece> m_droppingPieces;
	QList<Piece> m_disappearingPieces;
	int m_numDisappearingPieces;
	int m_numDroppingPieces;
};

#endif
