/***************************************************************************
                          ScoreBoard.cpp  -  description
                             -------------------
    begin                : Sun Dec 23 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ScoreBoard.h"
#include "GameSettings.h"

ScoreBoard::ScoreBoard()
	: QObject()
{
	reset();
}

ScoreBoard::~ScoreBoard()
{
}

void ScoreBoard::reset()
{
	m_score = 0;
	emit newScore(m_score);
}

void ScoreBoard::piecesRemoved(int numDirect, int numIndirect)
{
	m_score += 1+numDirect*numDirect;
	m_score += 10*numIndirect*numIndirect;
	emit newScore(m_score);
}

int ScoreBoard::addWinBonus(int numPiecesUsed, GameSettings *settings)
{
	int bonus;
	
	bonus = settings->bonusBaseScore() - 100*numPiecesUsed;
	bonus = (bonus < 0) ? 0 : bonus;
	bonus += 1000;			// win bonus
	m_score += bonus;
	emit newScore(m_score);
	return bonus;
}
