/***************************************************************************
                          ScoreBoard.h  -  description
                             -------------------
    begin                : Sun Dec 23 2001
    copyright            : (C) 2001 by Thorsten Scheuermann
    email                : tscheuermann@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SCOREBOARD_H
#define SCOREBOARD_H

#include <qobject.h>

/**
  *@author Thorsten Scheuermann
  */

class GameSettings;

class ScoreBoard : public QObject
{
Q_OBJECT

public: 
	ScoreBoard();
	~ScoreBoard();

	inline int score() const;
	int addWinBonus(int numPiecesUsed, GameSettings *settings);
	
signals:
	void newScore(int score);
	
public slots:
	void piecesRemoved(int numDirect, int numIndirect);
	void reset();
	
protected:
	int m_score;
};

inline int ScoreBoard::score() const
{
	return m_score;
}

#endif
